<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\Termin;

/**
 * TerminSearch represents the model behind the search form about `backend\models\Termin`.
 */
class TerminSearch extends Termin
{
    var $termin_parent_title;
    
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['termin_id', 'is_book'], 'integer'],
            [['termin_name', 'termin_title', 'termin_parent_title'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Termin::find();
        $query->select('*');

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        } 

        $query->joinWith(['terminLangs', 'terminStructures']);

        $query->andFilterWhere([
            'termin_id' => $this->termin_id,
            'is_book' => $this->is_book,
        ]);

        $query->andFilterWhere(['like', 'termin_name', $this->termin_name]);
        $query->andFilterWhere(['like', TerminLang::tableName().'.termin_title', $this->termin_title]);
        //$query->andFilterWhere(['like', 'termin_title', $this->termin_title]);

        return $dataProvider;
    }
}
